Debian Bug report logs - #689607
arm64 support for util-linux

version graph

Package: util-linux; Maintainer for util-linux is LaMont Jones <lamont@debian.org>; Source for util-linux is src:util-linux.

Reported by: Wookey <wookey@wookware.org>

Date: Thu, 4 Oct 2012 14:09:02 UTC

Severity: normal

Tags: patch, upstream

Found in version util-linux/2.17.2-9

Fixed in version util-linux/2.20.1-5.7

Done: wookey <wookey@wookware.org>

Reply or subscribe to this bug.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, kzak@redhat.com, LaMont Jones <lamont@debian.org>:
Bug#689607; Package util-linux. (Thu, 04 Oct 2012 14:09:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Wookey <wookey@wookware.org>:
New Bug report received and forwarded. Copy sent to kzak@redhat.com, LaMont Jones <lamont@debian.org>. (Thu, 04 Oct 2012 14:09:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Wookey <wookey@wookware.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: arm64 support for util-linux
Date: Thu, 04 Oct 2012 15:07:45 +0100
[Message part 1 (text/plain, inline)]
Package: util-linux
Version: 2.17.2-9
Severity: wishlist
Tags: upstream patch

util-linux needs a small fix for fdisk and autoconf updates to build
for 64-bit arm. The arm64 port is stalled until this package is updated.

Support for aarch64 has been added to autotools config.guess and
config.sub in autotools 20120210.1

For upstream running autoreconf against autotools-dev 20120210.1 or
later will fix the autoconf part.

For the Debian package, if you wanted to keep this up to date
automatically in the future (generally a good idea) then adding
something like this to your distclean target would be effective: -test
-r /usr/share/misc/config.sub && cp -f /usr/share/misc/config.sub
config.sub -test -r /usr/share/misc/config.guess && cp -f
/usr/share/misc/config.guess config.guess (You could instead just make
those files links.) along with a build-dependency on autotools-dev

Please pass this bug report to upstream (I hope I have CC:ed the right
person in this report)

-- System Information:
Debian Release: 6.0.6
  APT prefers stable
  APT policy: (990, 'stable')
Architecture: i386 (i686)

Kernel: Linux 2.6.32.33-kvm-i386-20111128-dirty (SMP w/1 CPU core)
Locale: LANG=en_GB.UTF-8, LC_CTYPE=en_GB.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash

Versions of packages util-linux depends on:
ii  debconf [debconf-2 1.5.36.1              Debian configuration management sy
ii  dpkg               1.15.8.13             Debian package management system
ii  initscripts        2.88dsf-13.1+squeeze1 scripts for initializing and shutt
ii  install-info       4.13a.dfsg.1-6        Manage installed documentation in 
ii  libblkid1          2.17.2-9              block device id library
ii  libc6              2.11.3-4              Embedded GNU C Library: Shared lib
ii  libncurses5        5.7+20100313-5        shared libraries for terminal hand
ii  libselinux1        2.0.96-1              SELinux runtime shared libraries
ii  libslang2          2.2.2-4               The S-Lang programming library - r
ii  libuuid1           2.17.2-9              Universally Unique ID library
ii  lsb-base           3.2-23.2squeeze1      Linux Standard Base 3.2 init scrip
ii  tzdata             2012c-0squeeze1       time zone and daylight-saving time
ii  zlib1g             1:1.2.3.4.dfsg-3      compression library - runtime

util-linux recommends no packages.

Versions of packages util-linux suggests:
ii  console-tools            1:0.2.3dbs-69.1 Linux console and font utilities
ii  dosfstools               3.0.9-1         utilities for making and checking 
pn  util-linux-locales       <none>          (no description available)

-- debconf information:
  util-linux/noauto-with-nonzero-passnum:
[util-linux-2.20.1-arm64.patch (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, LaMont Jones <lamont@debian.org>:
Bug#689607; Package util-linux. (Thu, 17 Jan 2013 05:27:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Colin Watson <cjwatson@ubuntu.com>:
Extra info received and forwarded to list. Copy sent to LaMont Jones <lamont@debian.org>. (Thu, 17 Jan 2013 05:27:03 GMT) Full text and rfc822 format available.

Message #10 received at 689607@bugs.debian.org (full text, mbox):

From: Colin Watson <cjwatson@ubuntu.com>
To: Wookey <wookey@wookware.org>, 689607@bugs.debian.org
Subject: Re: Bug#689607: arm64 support for util-linux
Date: Thu, 17 Jan 2013 05:25:50 +0000
On Thu, Oct 04, 2012 at 03:07:45PM +0100, Wookey wrote:
> Support for aarch64 has been added to autotools config.guess and
> config.sub in autotools 20120210.1
> 
> For upstream running autoreconf against autotools-dev 20120210.1 or
> later will fix the autoconf part.
> 
> For the Debian package, if you wanted to keep this up to date
> automatically in the future (generally a good idea) then adding
> something like this to your distclean target would be effective: -test
> -r /usr/share/misc/config.sub && cp -f /usr/share/misc/config.sub
> config.sub -test -r /usr/share/misc/config.guess && cp -f
> /usr/share/misc/config.guess config.guess (You could instead just make
> those files links.) along with a build-dependency on autotools-dev

This is all unnecessary.  util-linux already calls autoreconf in its
build target.

I second the fdisk/fdiskbsdlabel.h patch, though.

-- 
Colin Watson                                       [cjwatson@ubuntu.com]



Information forwarded to debian-bugs-dist@lists.debian.org, LaMont Jones <lamont@debian.org>:
Bug#689607; Package util-linux. (Sat, 09 Nov 2013 20:45:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Wookey <wookey@wookware.org>:
Extra info received and forwarded to list. Copy sent to LaMont Jones <lamont@debian.org>. (Sat, 09 Nov 2013 20:45:05 GMT) Full text and rfc822 format available.

Message #15 received at 689607@bugs.debian.org (full text, mbox):

From: Wookey <wookey@wookware.org>
To: 689607@bugs.debian.org
Subject: Re: Bug#689607: arm64 support for util-linux
Date: Sat, 9 Nov 2013 20:42:08 +0000
[Message part 1 (text/plain, inline)]
+++ Colin Watson [2013-01-17 05:25 +0000]:
> On Thu, Oct 04, 2012 at 03:07:45PM +0100, Wookey wrote:
> > Support for aarch64 has been added to autotools config.guess and
> > config.sub in autotools 20120210.1
> > 
> > For upstream running autoreconf against autotools-dev 20120210.1 or
> > later will fix the autoconf part.
> > 
> > For the Debian package, if you wanted to keep this up to date
> > automatically in the future (generally a good idea) then adding
> > something like this to your distclean target would be effective: -test
> > -r /usr/share/misc/config.sub && cp -f /usr/share/misc/config.sub
> > config.sub -test -r /usr/share/misc/config.guess && cp -f
> > /usr/share/misc/config.guess config.guess (You could instead just make
> > those files links.) along with a build-dependency on autotools-dev
> 
> This is all unnecessary.  util-linux already calls autoreconf in its
> build target.
> 
> I second the fdisk/fdiskbsdlabel.h patch, though.

Updated patch attached.

As the Debian arm64 port is now properly underway and this was filed
over a year ago, I propose to NMU this as otherwise it'll be an FTBFS soon.

Wookey
-- 
Principal hats:  Linaro, Emdebian, Wookware, Balloonboard, ARM
http://wookware.org/
[util-linux-2.20.1-arm64.patch (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#689607; Package util-linux. (Sun, 10 Nov 2013 00:15:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to LaMont Jones <lamont@debian.org>:
Extra info received and forwarded to list. (Sun, 10 Nov 2013 00:15:09 GMT) Full text and rfc822 format available.

Message #20 received at 689607@bugs.debian.org (full text, mbox):

From: LaMont Jones <lamont@debian.org>
To: Wookey <wookey@wookware.org>, 689607@bugs.debian.org
Subject: Re: Bug#689607: arm64 support for util-linux
Date: Sat, 9 Nov 2013 17:04:33 -0700
On Sat, Nov 09, 2013 at 08:42:08PM +0000, Wookey wrote:
> Updated patch attached.
> As the Debian arm64 port is now properly underway and this was filed
> over a year ago, I propose to NMU this as otherwise it'll be an FTBFS soon.

Do it.  I'm hoping that we'll have an upload before the month is over,
but there is work to do in the meantime.

lamont



Information forwarded to debian-bugs-dist@lists.debian.org, LaMont Jones <lamont@debian.org>:
Bug#689607; Package util-linux. (Sun, 10 Nov 2013 01:21:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Wookey <wookey@wookware.org>:
Extra info received and forwarded to list. Copy sent to LaMont Jones <lamont@debian.org>. (Sun, 10 Nov 2013 01:21:04 GMT) Full text and rfc822 format available.

Message #25 received at 689607@bugs.debian.org (full text, mbox):

From: Wookey <wookey@wookware.org>
To: LaMont Jones <lamont@debian.org>
Cc: 689607@bugs.debian.org
Subject: Re: Bug#689607: arm64 support for util-linux
Date: Sun, 10 Nov 2013 01:18:48 +0000
[Message part 1 (text/plain, inline)]
+++ LaMont Jones [2013-11-09 17:04 -0700]:
> On Sat, Nov 09, 2013 at 08:42:08PM +0000, Wookey wrote:
> > Updated patch attached.
> > As the Debian arm64 port is now properly underway and this was filed
> > over a year ago, I propose to NMU this as otherwise it'll be an FTBFS soon.
> 
> Do it.  I'm hoping that we'll have an upload before the month is over,
> but there is work to do in the meantime.

OK. cheers.

Testing, I see I screwed that last patch up. It should be like this one,
which is what I'll upload shortly.


Wookey
-- 
Principal hats:  Linaro, Emdebian, Wookware, Balloonboard, ARM
http://wookware.org/
[util-linux-2.20.1.arm64-support.patch (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, LaMont Jones <lamont@debian.org>:
Bug#689607; Package util-linux. (Sun, 10 Nov 2013 19:54:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Wookey <wookey@wookware.org>:
Extra info received and forwarded to list. Copy sent to LaMont Jones <lamont@debian.org>. (Sun, 10 Nov 2013 19:54:05 GMT) Full text and rfc822 format available.

Message #30 received at 689607@bugs.debian.org (full text, mbox):

From: Wookey <wookey@wookware.org>
To: LaMont Jones <lamont@debian.org>
Cc: 689607@bugs.debian.org
Subject: Re: Bug#689607: arm64 support for util-linux
Date: Sun, 10 Nov 2013 19:51:39 +0000
+++ LaMont Jones [2013-11-09 17:04 -0700]:
> On Sat, Nov 09, 2013 at 08:42:08PM +0000, Wookey wrote:
> > Updated patch attached.
> > As the Debian arm64 port is now properly underway and this was filed
> > over a year ago, I propose to NMU this as otherwise it'll be an FTBFS soon.
> 
> Do it.  I'm hoping that we'll have an upload before the month is over,
> but there is work to do in the meantime.

The package as patched with my last patch now builds fine on arm64, but
checking the build for amd64 I hit the m4 infinite memory usage bug
described in http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=724255 ,
so I haven't uploaded as it'll just get stuck on this problem in the buildds.

I'm guessing that is actually an m4 or autofoo problem rather than util-linux itself?


Wookey
-- 
Principal hats:  Linaro, Emdebian, Wookware, Balloonboard, ARM
http://wookware.org/



Severity set to 'normal' from 'wishlist' Request was from Wookey <wookey@stoneboat.aleph1.co.uk> to control@bugs.debian.org. (Mon, 06 Jan 2014 22:21:04 GMT) Full text and rfc822 format available.

Reply sent to wookey <wookey@wookware.org>:
You have taken responsibility. (Fri, 28 Mar 2014 15:39:05 GMT) Full text and rfc822 format available.

Notification sent to Wookey <wookey@wookware.org>:
Bug acknowledged by developer. (Fri, 28 Mar 2014 15:39:05 GMT) Full text and rfc822 format available.

Message #37 received at 689607-close@bugs.debian.org (full text, mbox):

From: wookey <wookey@wookware.org>
To: 689607-close@bugs.debian.org
Subject: Bug#689607: fixed in util-linux 2.20.1-5.7
Date: Fri, 28 Mar 2014 15:37:58 +0000
Source: util-linux
Source-Version: 2.20.1-5.7

We believe that the bug you reported is fixed in the latest version of
util-linux, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 689607@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
wookey <wookey@wookware.org> (supplier of updated util-linux package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@ftp-master.debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Fri, 28 Mar 2014 10:34:21 +0000
Source: util-linux
Binary: util-linux util-linux-locales mount bsdutils fdisk-udeb cfdisk-udeb libblkid1 libblkid1-udeb libblkid-dev libmount1 libmount1-udeb libmount-dev libuuid1 uuid-runtime libuuid1-udeb uuid-dev util-linux-udeb
Architecture: source all amd64
Version: 2.20.1-5.7
Distribution: unstable
Urgency: low
Maintainer: LaMont Jones <lamont@debian.org>
Changed-By: wookey <wookey@wookware.org>
Description: 
 bsdutils   - Basic utilities from 4.4BSD-Lite
 cfdisk-udeb - Manually partition a hard drive (cfdisk) (udeb)
 fdisk-udeb - Manually partition a hard drive (fdisk) (udeb)
 libblkid-dev - block device id library - headers and static libraries
 libblkid1  - block device id library
 libblkid1-udeb - block device id library (udeb)
 libmount-dev - block device id library - headers and static libraries
 libmount1  - block device id library
 libmount1-udeb - block device id library (udeb)
 libuuid1   - Universally Unique ID library
 libuuid1-udeb - stripped down universally unique id library, for debian-installer (udeb)
 mount      - Tools for mounting and manipulating filesystems
 util-linux - Miscellaneous system utilities
 util-linux-locales - Locales files for util-linux
 util-linux-udeb - Miscellaneous system utilities (udeb)
 uuid-dev   - universally unique id library - headers and static libraries
 uuid-runtime - runtime components for the Universally Unique ID library
Closes: 689607
Changes: 
 util-linux (2.20.1-5.7) unstable; urgency=low
 .
   * Non-maintainer upload.
   * Add arm64/aarch64 support (closes: #689607)
Checksums-Sha1: 
 d42767c42e707a0f0a5013b5145ee41a2865a249 2272 util-linux_2.20.1-5.7.dsc
 b570c850aba8e84d614ebc60b8138109e113922d 280790 util-linux_2.20.1-5.7.diff.gz
 22bcba0dda316af5b955a3f8a1123ea3564d3a6c 742720 util-linux-locales_2.20.1-5.7_all.deb
 ca4a6ac8b40d37cec9f4f0cabb13e1471095a026 500856 util-linux_2.20.1-5.7_amd64.deb
 ef325a8bc8a841f2675bd08cd6594e334a2aaaff 161154 mount_2.20.1-5.7_amd64.deb
 7646ffe7f35d44152f160220352706c325da1d5b 78904 bsdutils_2.20.1-5.7_amd64.deb
 5d9508aefec73257260b0868e0a8fe894c485e19 64912 fdisk-udeb_2.20.1-5.7_amd64.udeb
 769319e865af2d2a6a622401a7973df4b74bbe79 742880 cfdisk-udeb_2.20.1-5.7_amd64.udeb
 c6503d3733f37aa9e1520abccd2f52aeb0a1be8d 109796 libblkid1_2.20.1-5.7_amd64.deb
 688f31be9100a66c09003bdaac85c95a7511a494 61408 libblkid1-udeb_2.20.1-5.7_amd64.udeb
 854260feef117f7cd642e69032cc28b43c61b93d 127230 libblkid-dev_2.20.1-5.7_amd64.deb
 6683e5089859f21aaf66ff3d3b9c0ab8b95ea103 108390 libmount1_2.20.1-5.7_amd64.deb
 b1d4bc839b7242915c3e21c5b110780eb53f9108 59124 libmount1-udeb_2.20.1-5.7_amd64.udeb
 72854344a9cf80bcb8f9ee8797374aed62c9c222 116784 libmount-dev_2.20.1-5.7_amd64.deb
 64f6f9dc635856ecd16ed1d794bb6a19c9f0c2d0 56208 libuuid1_2.20.1-5.7_amd64.deb
 d359870b4372f0264b2c571cc1bff50afa2fb7be 58852 uuid-runtime_2.20.1-5.7_amd64.deb
 dd18d139a093a3692245dd7ceb91c858a9cc7860 7334 libuuid1-udeb_2.20.1-5.7_amd64.udeb
 f72ae01262d6acc25289a59c25fbb3b77024621a 70400 uuid-dev_2.20.1-5.7_amd64.deb
 b05d2ebeaf8d2ffd9c4585dc33dd2e05b1a91fe2 11990 util-linux-udeb_2.20.1-5.7_amd64.udeb
Checksums-Sha256: 
 c9cfbdd07b79df0d1335137f501af5bc4656aa6de4da367315de8e49020535c5 2272 util-linux_2.20.1-5.7.dsc
 d819d7c563019393637cbf0fbbbba35a4689188480301dbc7c83bf708b72133c 280790 util-linux_2.20.1-5.7.diff.gz
 d8902d150efac14c81c5208403fd853bf20f5c0208eb86765e0ce6043344cc22 742720 util-linux-locales_2.20.1-5.7_all.deb
 4db33e30a617d0b2ce846b6a94b0158824183f3ff8f6844b5e1f033ab7d6b1b6 500856 util-linux_2.20.1-5.7_amd64.deb
 0d70cc5e9c2dd89762ced0ebdd2dacdec274ce54cad6c4a463f826c4e16a0344 161154 mount_2.20.1-5.7_amd64.deb
 47b1cc0527c56017209ab1e7938509402e64340e52706970ec9962f133f12e09 78904 bsdutils_2.20.1-5.7_amd64.deb
 e4a78b936e904961ad7ef95edb9214cda55698e816c708ed5599c10f72e42f34 64912 fdisk-udeb_2.20.1-5.7_amd64.udeb
 50bc25efe2631405af13449c94cc3df4b2d29451ac2eb2f56c7cfce72ccda0a9 742880 cfdisk-udeb_2.20.1-5.7_amd64.udeb
 49a9413144c3db0b84b28be517dbcad97cf7307af15eefae396db0b221c0d097 109796 libblkid1_2.20.1-5.7_amd64.deb
 b84051a792aca17ab372ad0f17c0d3fb7d3bd492e927898987ae848addf61f35 61408 libblkid1-udeb_2.20.1-5.7_amd64.udeb
 44a48011c53b1c35bf830ce5d882cb4358ade8d8ffac6d7a9ce52ed455c63b84 127230 libblkid-dev_2.20.1-5.7_amd64.deb
 1cfed3427a89f15f919f0ce6919e3fcf4766b2d0db82d22e80333f26d43b71b5 108390 libmount1_2.20.1-5.7_amd64.deb
 6a124fe0c4b63e67fb5402a3b52060a4f7929d8f44245059697b29993ef38f83 59124 libmount1-udeb_2.20.1-5.7_amd64.udeb
 2594ec20cc5853e748a094ed5622d2e835e45125685e0c4ac0906836dc8dae98 116784 libmount-dev_2.20.1-5.7_amd64.deb
 805df4c2379d99947e83a5362f923f7aeafe1bb821909f56483932fc730849cd 56208 libuuid1_2.20.1-5.7_amd64.deb
 8cc195de7be479cc6d2c40dbf3d8548f54570021c331d36568a66ad5c6b93474 58852 uuid-runtime_2.20.1-5.7_amd64.deb
 fe1c16b44638d01e7c8993466f9220b4ea966baccdf8388e9c1bfa9f528405a0 7334 libuuid1-udeb_2.20.1-5.7_amd64.udeb
 300ad1df347079b3d0c78c15c845cf8f397bbeb55bf154c54424b864bdd9285f 70400 uuid-dev_2.20.1-5.7_amd64.deb
 ca8d199888272dda4f2df3b1fb01b72bb7e7b1a678f379fed454a119e57ecd12 11990 util-linux-udeb_2.20.1-5.7_amd64.udeb
Files: 
 5412222cb0fe9b201dc5af595a458ef5 2272 base required util-linux_2.20.1-5.7.dsc
 c7b7e4063ab659c43531e2beddbfb901 280790 base required util-linux_2.20.1-5.7.diff.gz
 07c7d23de09a13010c4583442c6b57d7 742720 utils optional util-linux-locales_2.20.1-5.7_all.deb
 32272e565c9d2df2f96411448d22f71b 500856 utils required util-linux_2.20.1-5.7_amd64.deb
 b5637af326c486859b5cda78f40de2b4 161154 admin required mount_2.20.1-5.7_amd64.deb
 e64611a41b0dd375c69a23778e7e71a4 78904 utils required bsdutils_2.20.1-5.7_amd64.deb
 aa1f2750c47363a8ce2b6a1a0366253e 64912 debian-installer extra fdisk-udeb_2.20.1-5.7_amd64.udeb
 6860744ef1113ffe662fc025a2b49d77 742880 debian-installer extra cfdisk-udeb_2.20.1-5.7_amd64.udeb
 7f85a3ca54b4b2be4c231650d9f13e92 109796 libs required libblkid1_2.20.1-5.7_amd64.deb
 35ff77dda34c970e78ee058e8d4d98a6 61408 debian-installer optional libblkid1-udeb_2.20.1-5.7_amd64.udeb
 5cb171a1477836098d30af860ccc60bb 127230 libdevel extra libblkid-dev_2.20.1-5.7_amd64.deb
 f65c842e0e737369f3cf934b623c10a1 108390 libs required libmount1_2.20.1-5.7_amd64.deb
 4277fdcf8ab0486739fb4d973591deb9 59124 debian-installer optional libmount1-udeb_2.20.1-5.7_amd64.udeb
 d45d417df186225413615f1d3b165788 116784 libdevel extra libmount-dev_2.20.1-5.7_amd64.deb
 6b5ca1694ac86f2e58361ba041fecab5 56208 libs required libuuid1_2.20.1-5.7_amd64.deb
 0d2f90722031af55a5f63ddb104e9023 58852 libs optional uuid-runtime_2.20.1-5.7_amd64.deb
 5a2566779e945b284889b656cdee58f1 7334 debian-installer optional libuuid1-udeb_2.20.1-5.7_amd64.udeb
 d03bd2d5cf782668ac3e05be0143c6e3 70400 libdevel extra uuid-dev_2.20.1-5.7_amd64.deb
 8d13e8cf191e2d145fed755cdc8b08c4 11990 debian-installer optional util-linux-udeb_2.20.1-5.7_amd64.udeb
Package-Type: udeb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iEYEARECAAYFAlM1fFkACgkQIWclcBdP7jUrRwCg1VLHsXmIEo0fKmqOkhRgB3OF
fgwAoLrnkGsH/oxqFivM3G9JjZVxXfz3
=2kqz
-----END PGP SIGNATURE-----




Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 16 23:57:09 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.